<template>
  <div>
    <div class="row-block bottom-20">
      <div class="col-block">
        <ob-input
          ref="inn"
          v-model="inn"
          :label="innTitle"
          :placeholder="`Введите ${innTitle}`"
          :disabled="isInputDisabled"
          :is-valid="innValidationStatus"
          :type="countryCode === 'blr' ? 'text' : 'number:strict'"
          property="inn"
          @input="oninput"
          @on-enter="checkInn"
        />
      </div>

      <div class="col-block">
        <transition
          name="fadeIn"
          mode="out-in"
        >
          <ObButton
            v-if="!innValidationStatus"
            :disabled="isCheckButtonDisabled"
            label="Проверить"
            type="outline"
            @click="checkInn"
          />

          <div
            v-else
            class="text-success"
          >
            {{ innTitle }}
            <template v-if="innTitle === 'ИНН'">существует</template>
            <template v-else>введён корректно</template>
          </div>
        </transition>
      </div>
    </div>

    <transition name="toggle-height">
      <div v-if="isParticipantExist">
        <p class="text-error ml0 mb20 mt20">
          Компания с таким {{ innTitle }} уже зарегистрирована
        </p>

        <p class="text-style -gray-slate">
          Если это ваша компания, свяжитесь со службой поддержки платформы
          {{ hostname === 'oboz' ? 'ОБОЗ' : 'ГрузиРу' }} по телефону

          <Contacts :hostname="hostname" />
        </p>
      </div>

      <div v-else-if="isPreregisteredParticipantExist">
        <p class="text-error ml0 mb20 mt20">
          Компания с таким {{ innTitle }} уже подала заявку на регистрацию
          на платформе {{ hostname === 'oboz' ? 'ОБОЗ' : 'ГрузиРу' }}
        </p>

        <p class="text-style -gray-slate">
          Если этот {{ innTitle }} принадлежит вашей компании, и никто
          из ваших сотрудников не подавал заявку на регистрацию, то
          свяжитесь со службой поддержки платформы
          {{ hostname === 'oboz' ? 'ОБОЗ' : 'ГрузиРу' }} по телефону

          <Contacts :hostname="hostname" />
        </p>
      </div>

      <div v-else-if="innValidationStatus && isIndividual && countryCode === 'rus' && errorCode === 'unknown'">
        <p class="text-style --big mb30">
          Кажется, {{ innTitle }} принадлежит физическому лицу.

          <a
            href="#"
            class="link-style"
            @click="resetAll"
          >
            Ввести другой {{ innTitle }}
          </a>
        </p>
      </div>

      <div v-else-if="isCheckPassed === false">
        <p class="text-error ml0 mb20 mt20">
          Не получается проверить указанный {{ innTitle }}.
        </p>

        <p class="text-style -gray-slate">
          Попробуйте ещё раз или свяжитесь со службой поддержки
          платформы {{ hostname === 'oboz' ? 'ОБОЗ' : 'ГрузиРу' }} по телефону

          <Contacts :hostname="hostname" />
        </p>
      </div>
    </transition>
  </div>
</template>

<script>
  import api from '@/api'
  import Contacts from './contacts'
  import ObInput from 'common-components/src/obComponents/obInput'
  import ObButton from 'common-components/src/obComponents/obButton'

  export default {
    name: 'innField',
    components: {
      Contacts,
      ObInput,
      ObButton
    },
    props: {
      disabled: {
        type: Boolean,
        required: true
      },
      hostname: {
        type: String,
        required: true
      },
      phoneCheckUuid: {
        type: String,
        default: null
      },
      countryCode: {
        type: String,
        required: true
      },
      errorsMap: {
        type: Object,
        required: true
      }
    },
    data () {
      return {
        inn: '',
        errorCode: null,
        isCheckPassed: null,
        isParticipantExist: false,
        isPreregisteredParticipantExist: false
      }
    },
    computed: {
      isInputDisabled () {
        switch (true) {
          case this.disabled:
            return true

          case ['blr', 'kaz'].includes(this.countryCode):
            return false

          case this.innValidationStatus:
            return true

          default:
            return false
        }
      },
      isCheckButtonDisabled () {
        return this.isInputDisabled || !this.inn || !this.isValidLength
      },
      innValidationStatus () {
        switch (true) {
          case this.isExists:
          case this.inn && !this.isValidLength:
            return false

          case this.isCheckPassed === true:
            return true

          // Предположение, что физическое лицо
          case (
            this.isCheckPassed === false &&
            this.isIndividual &&
            this.countryCode === 'rus' &&
            this.errorCode === 'unknown'
          ):
            this.$emit('change', true, {}, this.inn)
            return true

          default:
            return null
        }
      },
      isExists () {
        return this.isParticipantExist || this.isPreregisteredParticipantExist
      },
      isValidLength () {
        // For countries with 'Reg code'
        if (!this.individualDocumentLength) {
          return true
        }

        return [this.individualDocumentLength, this.nonIndividualDocumentLength].includes(this.inn.length)
      },
      isIndividual () {
        return this.inn.length === this.individualDocumentLength
      },
      innTitle () {
        switch (this.countryCode) {
          case 'rus':
            return 'ИНН'

          case 'kaz':
            return 'БИН/ИИН'

          case 'blr':
            return 'УНП'

          default:
            return 'Reg code'
        }
      },
      nonIndividualDocumentLength () {
        switch (this.countryCode) {
          case 'rus':
            return 10

          case 'kaz':
            return 12

          case 'blr':
            return 9

          default:
            return null
        }
      },
      individualDocumentLength () {
        switch (this.countryCode) {
          case 'rus':
            return 12

          case 'kaz':
            return 14

          case 'blr':
            return 9

          default:
            return null
        }
      }
    },
    methods: {
      async checkInn () {
        this.$refs.inn.dirty = true

        try {
          const card = await api.registration.register.getInfoByInn({
            uuid: this.phoneCheckUuid,
            inn: this.inn,
            countrySymbolCode: this.countryCode
          })

          this.isCheckPassed = true

          this.$emit('change', {
            isInnValid: true,
            card: card || {},
            inn: this.inn,
            isKppCheckNeed: !this.isIndividual
          })
        } catch (e) {
          switch (e.errorCode) {
            case '409':
              this.isParticipantExist = true
              break

            case 'not_found':
              this.$emit('reset-phone-sms')
              this.resetState()
              return
          }

          this.isCheckPassed = false
          this.errorCode = e.errorCode

          this.$emit('change', false)
        }
      },
      oninput () {
        this.$emit('change')

        this.resetState()
      },
      onError (error) {
        this[this.errorsMap[error.code]] = true

        this.$emit('change', false)
      },
      resetState () {
        this.errorCode = null
        this.isCheckPassed = null
        this.isParticipantExist = false
        this.isPreregisteredParticipantExist = false
      },
      resetAll () {
        this.$emit('change')

        this.clear()
      },
      clear () {
        this.inn = ''

        this.resetState()
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .bottom-20 {
    margin-bottom: 20px;
  }

  .row-block {
    display: flex;
    align-items: center;
    height: 100%;

    .col-block {
      &:first-of-type {
        width: 204px;
      }

      &:last-of-type {
        width: calc(100% - 211px);
        margin-left: 7px;
      }
    }
  }

  .text-style {
    @include font-mixin(12px, 18px, 400);

    &.--big {
      font-size: 14px;
      line-height: 20px;
    }
  }

  .text-success {
    @include font-mixin(12px, 14px, 400, $caribbean-green, 0.4px);

    margin-left: 13px;
  }

  .text-error {
    @include font-mixin(12px, 14px, 400, $light-raspberry-red, 0.4px);

    margin-left: 13px;
  }
</style>